/*
---------------------------------------------------------------------
---       EPWIC-1 (Embedded Predictive Wavelet Image Coder)       ---
---    Designed by Robert W. Buccigrossi and Eero P. Simoncelli   ---
---               Developed at the GRASP Laboratory               ---
---          Copyright 1997, University of Pennsylvania           ---
---                      All rights reserved.                     ---
---------------------------------------------------------------------

Permission to use, copy, or modify this software and its documentation
for educational and research purposes only and without fee is hereby
granted, provided that this copyright notice appear on all copies and
supporting documentation.  For any other uses of this software, in
original or modified form, including but not limited to distribution
in whole or in part, specific prior permission must be obtained from
U Penn and the authors.  These programs shall not be used, rewritten,
or adapted as the basis of a commercial software or hardware product
without first obtaining appropriate licenses from U Penn.  U Penn
makes no representations about the suitability of this software for
any purpose.  It is provided "as is" without express or implied
warranty.

---------------------------------------------------------------------
*/

#ifndef _PROB_DIST_H
#define _PROB_DIST_H

void estimate_pdf(Pyramid pyr, int subband, double *s, double *p);

void init_prior(int num_levels);

int exist_prior(int subband);

void calc_prior(int subband, double s, double p);

double get_prior_CDF(int subband, int value);

void init_estimation_fraction(int subband, int read_to_bit);

Coefficient get_estimation_fraction(Coefficient coef);

#endif
