/*
---------------------------------------------------------------------
---       EPWIC-1 (Embedded Predictive Wavelet Image Coder)       ---
---    Designed by Robert W. Buccigrossi and Eero P. Simoncelli   ---
---               Developed at the GRASP Laboratory               ---
---          Copyright 1997, University of Pennsylvania           ---
---                      All rights reserved.                     ---
---------------------------------------------------------------------

Permission to use, copy, or modify this software and its documentation
for educational and research purposes only and without fee is hereby
granted, provided that this copyright notice appear on all copies and
supporting documentation.  For any other uses of this software, in
original or modified form, including but not limited to distribution
in whole or in part, specific prior permission must be obtained from
U Penn and the authors.  These programs shall not be used, rewritten,
or adapted as the basis of a commercial software or hardware product
without first obtaining appropriate licenses from U Penn.  U Penn
makes no representations about the suitability of this software for
any purpose.  It is provided "as is" without express or implied
warranty.

---------------------------------------------------------------------
*/

#ifndef _RUN_LENGTH
#define _RUN_LENGTH

#include <stdio.h>
#include "arith.h"

/* encoding */
int run_length_encode_zeros (unsigned char *block, int block_size, 
                             unsigned char * encoded_stream, 
			     int zero_block_size,
                             int raw_block_size);

/* decoding */
void rle_init_decode(FILE *infile,int zero_block_size,int raw_block_size,
		     arithcode *acode);
int rle_bytes_read();
int rle_read_bit(int *bit);
int rle_read_byte(unsigned char *sym);
int rle_read_bit_by_byte(int *bit);
int rle_read_short(unsigned short *sym);
int rle_read_int(unsigned int *sym);
int rle_read_array(void *ptr, int ptrsize, int arraysize);

#endif /* _RUN_LENGTH */

